; ⥩ 㠫쭠 設
emCODEsize EQU 1024
emDATAsize EQU 1024
.MODEL TINY
.CODE
.286
ORG 100h
Start:

printf	MACRO String
LOCAL	jm, s1
	PUSH	DX
	MOV	AH, 9
	LEA	DX, s1
	INT	21h
	POP	DX
	JMP	Short jm
s1		DB &String, '$'
jm:
ENDM

; ////////////////////////////////////////////////////////////////
; //		   	롮ન	権			//
; //------------------------------------------------------------//
	MOV	AX,CS
	MOV	ES,AX
	MOV	DS,AX
	LEA	SI,emCODE

	printf <0Dh,0Ah,"(c) KPNC VIRTUAL CPU EMULATOR 0.1 ",0Dh,0Ah>
Repeat:
	LODSW
	XCHG	AX,BX
	LODSW
	XCHG	AX,CX
	LODSW
	XCHG	AX,DX
	CALL	Execute
	CALL	DEBUG_CheckEsc
	JMP	SHORT	Repeat

Execute		proc near
	CMP	[BX-2],0ACEDh
	JZ	ex_ok
	printf	<0Dh,0Ah,'⭠ ',0DH,0Ah,07>
	CALL	DEBUG_ABORT
ex_ok:
	CALL	DEBUG_PRINT
	CALL	BX
	RETN
endp

DW 0ACEDh
emBreak:
	INT 03
	RETN







	DB ' emADD      ','$'
	DW 0ACEDh
emADD:
	XCHG	AX,DX
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	XCHG	AX,BP

	XCHG	AX,CX
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	ADD	AX,BP
	CALL	SetWordToPh
	RETN

	DB ' emIF       ','$'
	DW 0ACEDH
emIF:
	MOV	AX,CX
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	XCHG	AX,BP

	MOV	AX,CX
	ADD	AX,2
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	ADD	CX,4
	CMP	BP,AX
	JB	_emIf_ok
	JZ	_emif_eu
	ADD	CX,2
_emif_eu:
	ADD	CX,2
_emif_ok:
	MOV	AX,CX
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	CALL	EmToPhCODEAddr
	MOV	SI,AX
	RETN

	DB ' emWritePort','$'
	DW 0ACEDh
emWritePort:
	XCHG	AX,CX
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	XCHG	AX,BP
	CALL	emPortToProc


	MOV	[BX-2],BP
	MOV	Byte ptr DS:[BX-3],0FFh
	CALL	BX
	RETN

DB ' emReadPort ','$'
DW 0ACEDh
emReadPort:
	XCHG	AX,CX
	CALL	EmToPhDATAAddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	XCHG	AX,BP
	CALL	emPortToProc

	MOV	[BX-2],BP
	MOV	Byte ptr DS:[BX-3],00h
	CALL	BX
	RETN

	DB ' SetDebug   ','$'
	DW  0ACEDH
emSetDEBUG:
	XCHG	 AX,CX
	CALL	EmToPhDATAaddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	MOV	[emIREG_DEBUG],AX
	RETN




DEBUG_WRITE	proc near
	PUSH	DX
	XCHG	DX,AX
	MOV	AH,9
	INT	21h
	POP	DX
	RETN
ENDP

DEBUG_PRINT:
	CMP	[emIREG_DEBUG],0
	JZ	d_p_exit
	printf	<0Dh>
	MOV	AX, SI
	CALL	PhToEmCODEAddr
	CALL	WriteHexWord
	PUSH	DX
	PUSH	CX
	MOV	AX,BX
	SUB	AX,15
	CALL	DEBUG_Write
	POP	AX
	CALL	WriteHexWord
	printf	<" ">
	POP	AX
	CALL	WriteHexWord
	printf	<0Dh, 0Ah>
d_p_exit:
	RETN



DEBUG_CheckEsc	proc near
	MOV	AH,1
	INT	16h
	JZ	d_ce_exit
	XOR	AX,AX
	INT	16h
	CMP	AL,27
	JNZ	d_ce_exit
	Printf	<"Exiting",0Dh,0Ah>
	CALL	DEBUG_Abort
d_ce_exit:
	RETN
ENDP

DEBUG_Abort	proc near
	printf	<"Aborting">
	MOV	AH,4CH
	INT	21h
	RETN
ENDP


WriteHexWord:
	PUSHA
	MOV	BX, AX
	MOV	CX, 4
	MOV	AH,6
@III:
	ROL	BX, 4
	MOV	DL, BL
	AND	DL, 00001111B
	ADD	DL, '0'
	CMP	DL, '9'
	JNA	@Less
	ADD	DL, 7
@Less:
	INT	21h
	LOOP	@III
	POPA
	RET


; ////////////////////////////////////////////////////////////////
; //			   HAL				//
; //------------------------------------------------------------//
; //								//

; ////////////////////////////////////////////////////////////////
; //		SelectPhAddr (AX):none				//
; //------------------------------------------------------------//
; // 롮ઠ 䨧᪮ 	। 樥	⥭\	//
; // 易 㭪樨 : GetWordFrmPh,SetWordFrmPh		//
SelectPhAddr	PROC NEAR
	MOV	[emIREG_MemSel],AX
	RETN
ENDP


; ////////////////////////////////////////////////////////////////
; //		    GetWordFromPh (AX):AX			//
; //------------------------------------------------------------//
; // ⥭ ᫮   䨧᪮ 		//
; // 易 㭪樨:EmToPhCODEaddr,EmToPhDATAaddr		//
GetWordFromPh	 PROC NEAR
	MOV	BX,[emIREG_MemSel]
	MOV	AX,[BX]
	RETN
ENDP

; ////////////////////////////////////////////////////////////////
; //		    SetWordFromPh (AX):AX			//
; //------------------------------------------------------------//
; //  ᫮  	䨧᪮ 		//
; // 易 㭪樨:EmToPhCODEaddr,EmToPhDATAaddr		//
SetWordToPh	PROC NEAR
	MOV	BX,[emIREG_MemSel]
	MOV	[BX],AX
	RETN
ENDP


; ////////////////////////////////////////////////////////////////
; //  PhToEmDATAaddr   ᪨ 	--> 㠫		//
; //------------------------------------------------------------//
PhToEmDATAaddr	PROC NEAR
	SUB	AX,offset emDATA
	RETN
ENDP

; ////////////////////////////////////////////////////////////////
; //  EmToPhDATAaddr   㠫  --> ᪨		//
; //------------------------------------------------------------//
EmToPhDATAaddr	PROC NEAR
	ADD	AX,offset emDATA
	RETN
ENDP

; ////////////////////////////////////////////////////////////////
; //  PhToEmCODEaddr   ᪨ 	--> 㠫		//
; //------------------------------------------------------------//
PhToEmCODEaddr PROC NEAR
	SUB	AX,offset emCODE
	RETN
ENDP

; ////////////////////////////////////////////////////////////////
; //  EmToPhDATAaddr   㠫  --> ᪨		//
; //------------------------------------------------------------//
EmToPhCODEaddr PROC NEAR
	ADD	AX,offset emCODE
	RETN
ENDP


EmPortToProc:
	PUSH	SI
	LEA	SI,PortMatrix

emport_repeat:
	LODSW
	OR	AX,AX
	JZ	em_port_ok
	CMP	AX,DX
	LODSW
	JNZ	emport_repeat
em_port_ok:
	OR	AX,AX
	JNZ	em_port_exit

	LEA	AX,emNull

em_port_exit:
	XCHG	BX,AX
	POP	SI
	RETN


PortMatrix:
	DW 077h
	DW Offset emConsole
	DW 0

	DB 0
	DW 0
emNull:
	MOV	AX,0FFh
	RETN


em_c_mode	DB 0
em_c_mem	DW 0
emConsole:
	CMP	[em_c_mode],0
	JZ	em_c_read

em_c_write:
	MOV	AX,[em_c_mem]
	CALL	EmToPhDATAaddr
	CALL	SelectPhAddr
	CALL	GetWordFromPh
	XCHG	AX,DX
	MOV	AH,6
	INT	21h
	RETN
em_c_read:

	XOR	AX,AX
	INT	16h
	PUSH	AX
	MOV	AX,[em_c_mem]
	CALL	EmToPhDATAaddr
	CALL	SelectPhAddr
	POP	AX
	CALL	SetWordToPh
	RETN

	RETN




emIREG_MemSel	DW 0
emIREG_DEBUG	DW 0

emCODE:
   DW Offset emWritePort
   DW 0
   DW 77h

   DW offset emADD
   DW 0
   DW offset const1-offset emDATA

prg_repeat:
   DW emIF
   DW 0
   DW 0FFh

LoadPassword:
   DW offset emReadPort
   DW offset pPasw - offset emDATA
   DW 77h

WriteChar:
   DW offset emWritePort
   DW offset pPasw - offset emDATA
   DW 77h

   DW offset emADD
   DW offset pPasw - offset emDATA
   DW offset const1 - offset emDATA


   DW offset emIF
   DW offset pPasw - offset emDATA
   DW 0

prg_enter_psw:
   DW offset emBreak
   DW 0
   DW 0

   DW offset emADD
   DW offset endPasw - offset emDATA - 2
   DW offset Pasw - offset emDATA


CalculateCRC:
	DW offset emADD
	DW offset CalcCRC - offset emDATA
	DW offset endPasw - offset emDATA - 2

	DW offset emIF
	DW offset CalcCRC - offset emDATA
	DW 0FFFFh


prg_valid_psw:
   DW Offset emWritePort
   DW offset endvalid -	offset emDATA
   DW 77h

   DW offset emADD
   DW offset EndValid -	offset emDATA
   DW offset const1-offset emDATA

prg_valid_end:
   DW emIF
   DW offset endValid-offset emDATA
   DW 0FFh

Prg_invalid_psw:
   DW Offset emWritePort
   DW offset endError -	offset emDATA
   DW 77h

   DW offset emADD
   DW offset EndError -	offset emDATA
   DW offset const1-offset emDATA

prg_invalid_end:
   DW emIF
   DW offset endError-offset emDATA
   DW 0FFh




_code:
   DB (emCODEsize + offset _code - offset emCODE) DUP (0)

emDATA:
       DW offset String	- offset emDATA
       DW offset endString -  offset emDATA
       DW 0
       DW offset LoadPassword -	offset emCODE
       DW offset LoadPassword -	offset emCODE

const1	DW 1
String:
       DB 'Enter password : '
endString:

pPasw  DW offset Pasw -	offset emDATA
lPasw  DW offset endPasw- offset emDATA
       DW offset LoadPassword -	offset emCODE
       DW offset prg_enter_psw - offset	emCODE
       DW offset prg_enter_psw - offset	emCODE
Pasw   DB '.....'
endPasw:


CalcCRC	DW 0
TrueCRC	DW 7B8Eh+0Dh
	DW offset prg_invalid_psw - offset emCODE
	DW offset prg_valid_psw	- offset emCODE
	DW offset prg_invalid_psw - offset emCODE

Valid  DB 0Dh,0Ah,'Password OK :)'
endValid:
       DW offset Valid - offset	emDATA
       DW offset endValid - offset emDATA
       DW offset prg_valid_psw - offset	emCODE
       DW offset prg_valid_end - offset	emCODE
       DW offset prg_valid_end - offset	emCODE

Error  DB 0Dh,0Ah,'Password fail :('
endError:
       DW offset Error - offset	emDATA
       DW offset endError - offset emDATA
       DW offset prg_invalid_psw - offset emCODE
       DW offset prg_invalid_end - offset emCODE
       DW offset prg_invalid_end - offset emCODE



  ret
END Start
